SystemOrganization addCategory: #'Fun-With-Traits'!
SystemOrganization addCategory: 'Fun-With-Traits-Sketch-Cache-MOP'!

Trait named: #CrossCuttingConcerns
	uses: {}
	category: 'Fun-With-Traits'!

!CrossCuttingConcerns methodsFor: 'view-cross-cutting-concern' stamp: 'NickPapoulias 8/26/2015 17:38'!
clearAllConcerns

	self concerns keysDo: [ :selector | self clearConcernOf: selector ]! !

!CrossCuttingConcerns methodsFor: 'view-cross-cutting-concern' stamp: 'NickPapoulias 8/26/2015 17:38'!
clearConcernOf: aSelector 

	(self concerns removeKey: aSelector ifAbsent: [ nil ])
		ifNotNilDo: [:wrapper | wrapper uninstall ]! !

!CrossCuttingConcerns methodsFor: 'view-cross-cutting-concern' stamp: 'NickPapoulias 8/26/2015 15:34'!
concernOf: aSelector

	^ self concerns at: aSelector ifAbsent: [ nil ]! !

!CrossCuttingConcerns methodsFor: 'view-cross-cutting-concern' stamp: 'NickPapoulias 8/26/2015 14:53'!
concerns

	^ (self getShared: #concerns) 
		ifNil: [ self setShared: #concerns to: Dictionary new ]! !

!CrossCuttingConcerns methodsFor: 'view-cross-cutting-concern' stamp: 'NickPapoulias 8/26/2015 18:27'!
do: anotherBlock after: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].
	concern 
		compiledMethod: self class >> aSelector;
		after: anotherBlock;
		install.! !

!CrossCuttingConcerns methodsFor: 'view-cross-cutting-concern' stamp: 'NickPapoulias 8/26/2015 18:27'!
do: anotherBlock before: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new ].
	concern 
		compiledMethod: self class >> aSelector;
		before: anotherBlock;
		install.! !

!CrossCuttingConcerns methodsFor: 'view-cross-cutting-concern' stamp: 'NickPapoulias 8/26/2015 18:27'!
do: anotherBlock insteadOf: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new ].
	concern 
		compiledMethod: (self class >> aSelector);
		instead: anotherBlock;
		install.! !

!CrossCuttingConcerns methodsFor: 'view-cross-cutting-concern' stamp: 'NickPapoulias 8/26/2015 18:27'!
if: aBlock do: anotherBlock after: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].
	concern 
		compiledMethod: (self class >> aSelector);
		after: anotherBlock;
		afterCondition: aBlock;
		install.! !

!CrossCuttingConcerns methodsFor: 'view-cross-cutting-concern' stamp: 'NickPapoulias 8/26/2015 18:27'!
if: aBlock do: anotherBlock before: aSelector

	| concern |
	concern := self concerns at: aSelector
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new ].
	concern 
		compiledMethod:  self class >> aSelector;
		before: anotherBlock;
		beforeCondition: aBlock;
		install.! !

!CrossCuttingConcerns methodsFor: 'view-cross-cutting-concern' stamp: 'NickPapoulias 8/26/2015 18:27'!
if: aBlock do: anotherBlock insteadOf: aSelector

	| concern |
	concern := self concerns at: aSelector
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].
	concern 
		compiledMethod: self class >> aSelector;
		instead: anotherBlock;
		insteadCondition: aBlock;
		install.! !

Trait named: #DynamicState
	uses: {}
	category: 'Fun-With-Traits'!

!DynamicState methodsFor: 'view-dynamic-state' stamp: 'NickPapoulias 8/26/2015 11:33'!
get: anId

	^ (self getShared: self) 
			ifNil: [ nil ]  
			ifNotNilDo: [:dynIvs | dynIvs at: anId ifAbsent: [ nil ]]
! !

!DynamicState methodsFor: 'view-dynamic-state' stamp: 'NickPapoulias 8/26/2015 11:24'!
getShared: anId

	^ self class propertyValueAt: anId! !

!DynamicState methodsFor: 'view-dynamic-state' stamp: 'NickPapoulias 8/26/2015 12:07'!
remove: anId
		
	^ (self getShared: self) 
			ifNil: [ nil ]
			ifNotNilDo: [ :dynIvs | dynIvs removeKey: anId ]
! !

!DynamicState methodsFor: 'view-dynamic-state' stamp: 'NickPapoulias 8/26/2015 12:04'!
removeShared: anId
		
	^ self class removeProperty: anId
! !

!DynamicState methodsFor: 'view-dynamic-state' stamp: 'NickPapoulias 8/26/2015 11:38'!
set: anId to: anObject

	^ ((self getShared: self) ifNil: [ self setShared: self to: Dictionary new ])  
			at: anId put: anObject.
		
	
! !

!DynamicState methodsFor: 'view-dynamic-state' stamp: 'NickPapoulias 8/26/2015 11:36'!
setShared: anId to: anObject

	^ self class propertyValueAt: anId put: anObject! !

Trait named: #Visibility
	uses: {}
	category: 'Fun-With-Traits'!

Visibility classTrait
	uses: CrossCuttingConcerns classTrait + DynamicState classTrait!

Trait named: #View
	uses: DynamicState + CrossCuttingConcerns + Visibility
	category: 'Fun-With-Traits'!

View classTrait
	uses: DynamicState classTrait + CrossCuttingConcerns classTrait + Visibility classTrait!

Trait named: #Memoization
	uses: View
	category: 'Fun-With-Traits'!

Memoization classTrait
	uses: View classTrait!

!Memoization methodsFor: 'view-cross-cutting-concern' stamp: ''!
clearAllConcerns

	self concerns keysDo: [ :selector | self clearConcernOf: selector ]! !

!Memoization methodsFor: 'view-cross-cutting-concern' stamp: ''!
clearConcernOf: aSelector 

	(self concerns removeKey: aSelector ifAbsent: [ nil ])
		ifNotNilDo: [:wrapper | wrapper uninstall ]! !

!Memoization methodsFor: 'view-cross-cutting-concern' stamp: ''!
concernOf: aSelector

	^ self concerns at: aSelector ifAbsent: [ nil ]! !

!Memoization methodsFor: 'view-cross-cutting-concern' stamp: ''!
concerns

	^ (self getShared: #concerns) 
		ifNil: [ self setShared: #concerns to: Dictionary new ]! !

!Memoization methodsFor: 'view-cross-cutting-concern' stamp: ''!
do: anotherBlock after: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].
	concern 
		compiledMethod: self class >> aSelector;
		after: anotherBlock;
		install.! !

!Memoization methodsFor: 'view-cross-cutting-concern' stamp: ''!
do: anotherBlock before: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new ].
	concern 
		compiledMethod: self class >> aSelector;
		before: anotherBlock;
		install.! !

!Memoization methodsFor: 'view-cross-cutting-concern' stamp: ''!
do: anotherBlock insteadOf: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new ].
	concern 
		compiledMethod: (self class >> aSelector);
		instead: anotherBlock;
		install.! !

!Memoization methodsFor: 'view-dynamic-state' stamp: ''!
get: anId

	^ (self getShared: self) 
			ifNil: [ nil ]  
			ifNotNilDo: [:dynIvs | dynIvs at: anId ifAbsent: [ nil ]]
! !

!Memoization methodsFor: 'view-dynamic-state' stamp: ''!
getShared: anId

	^ self class propertyValueAt: anId! !

!Memoization methodsFor: 'view-visibility' stamp: ''!
hidden: aSelector

	|concern| 

	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].

	concern 
		visibleFromCollection: {}.! !

!Memoization methodsFor: 'view-cross-cutting-concern' stamp: ''!
if: aBlock do: anotherBlock after: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].
	concern 
		compiledMethod: (self class >> aSelector);
		after: anotherBlock;
		afterCondition: aBlock;
		install.! !

!Memoization methodsFor: 'view-cross-cutting-concern' stamp: ''!
if: aBlock do: anotherBlock before: aSelector

	| concern |
	concern := self concerns at: aSelector
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new ].
	concern 
		compiledMethod:  self class >> aSelector;
		before: anotherBlock;
		beforeCondition: aBlock;
		install.! !

!Memoization methodsFor: 'view-cross-cutting-concern' stamp: ''!
if: aBlock do: anotherBlock insteadOf: aSelector

	| concern |
	concern := self concerns at: aSelector
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].
	concern 
		compiledMethod: self class >> aSelector;
		instead: anotherBlock;
		insteadCondition: aBlock;
		install.! !

!Memoization methodsFor: 'memoization-protocol' stamp: 'NickPapoulias 8/27/2015 14:57'!
memoize: aSelector! !

!Memoization methodsFor: 'memoization-protocol' stamp: 'NickPapoulias 8/27/2015 15:09'!
memoize: aSelector usingCache: aCache  ! !

!Memoization methodsFor: 'view-visibility' stamp: ''!
message: aSelector isVisibleFrom: aCollectionOfClasses

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].

	concern 
		compiledMethod: self class >> aSelector;
		visibleFromCollection: aCollectionOfClasses;
		install.! !

!Memoization methodsFor: 'view-visibility' stamp: ''!
private: aSelector

	self message: aSelector isVisibleFrom: { self class }! !

!Memoization methodsFor: 'view-visibility' stamp: ''!
protected: aSelector

	self message: aSelector isVisibleFrom:  (self class allSubclasses add: self class) ! !

!Memoization methodsFor: 'view-visibility' stamp: ''!
public: aSelector

	|concern| 

	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].

	concern 
		visibleFromCollection: nil.! !

!Memoization methodsFor: 'view-dynamic-state' stamp: ''!
remove: anId
		
	^ (self getShared: self) 
			ifNil: [ nil ]
			ifNotNilDo: [ :dynIvs | dynIvs removeKey: anId ]
! !

!Memoization methodsFor: 'view-dynamic-state' stamp: ''!
removeShared: anId
		
	^ self class removeProperty: anId
! !

!Memoization methodsFor: 'view-dynamic-state' stamp: ''!
set: anId to: anObject

	^ ((self getShared: self) ifNil: [ self setShared: self to: Dictionary new ])  
			at: anId put: anObject.
		
	
! !

!Memoization methodsFor: 'view-dynamic-state' stamp: ''!
setShared: anId to: anObject

	^ self class propertyValueAt: anId put: anObject! !

!Memoization methodsFor: 'memoization-protocol' stamp: 'NickPapoulias 8/27/2015 14:59'!
unmemoize: aSelector! !

!Memoization methodsFor: 'memoization-protocol' stamp: 'NickPapoulias 8/27/2015 14:58'!
update: aSelector! !

!View methodsFor: 'view-cross-cutting-concern' stamp: ''!
clearAllConcerns

	self concerns keysDo: [ :selector | self clearConcernOf: selector ]! !

!View methodsFor: 'view-cross-cutting-concern' stamp: ''!
clearConcernOf: aSelector 

	(self concerns removeKey: aSelector ifAbsent: [ nil ])
		ifNotNilDo: [:wrapper | wrapper uninstall ]! !

!View methodsFor: 'view-cross-cutting-concern' stamp: ''!
concernOf: aSelector

	^ self concerns at: aSelector ifAbsent: [ nil ]! !

!View methodsFor: 'view-cross-cutting-concern' stamp: ''!
concerns

	^ (self getShared: #concerns) 
		ifNil: [ self setShared: #concerns to: Dictionary new ]! !

!View methodsFor: 'view-cross-cutting-concern' stamp: ''!
do: anotherBlock after: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].
	concern 
		compiledMethod: self class >> aSelector;
		after: anotherBlock;
		install.! !

!View methodsFor: 'view-cross-cutting-concern' stamp: ''!
do: anotherBlock before: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new ].
	concern 
		compiledMethod: self class >> aSelector;
		before: anotherBlock;
		install.! !

!View methodsFor: 'view-cross-cutting-concern' stamp: ''!
do: anotherBlock insteadOf: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new ].
	concern 
		compiledMethod: (self class >> aSelector);
		instead: anotherBlock;
		install.! !

!View methodsFor: 'view-dynamic-state' stamp: ''!
get: anId

	^ (self getShared: self) 
			ifNil: [ nil ]  
			ifNotNilDo: [:dynIvs | dynIvs at: anId ifAbsent: [ nil ]]
! !

!View methodsFor: 'view-dynamic-state' stamp: ''!
getShared: anId

	^ self class propertyValueAt: anId! !

!View methodsFor: 'view-visibility' stamp: ''!
hidden: aSelector

	|concern| 

	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].

	concern 
		visibleFromCollection: {}.! !

!View methodsFor: 'view-cross-cutting-concern' stamp: ''!
if: aBlock do: anotherBlock after: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].
	concern 
		compiledMethod: (self class >> aSelector);
		after: anotherBlock;
		afterCondition: aBlock;
		install.! !

!View methodsFor: 'view-cross-cutting-concern' stamp: ''!
if: aBlock do: anotherBlock before: aSelector

	| concern |
	concern := self concerns at: aSelector
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new ].
	concern 
		compiledMethod:  self class >> aSelector;
		before: anotherBlock;
		beforeCondition: aBlock;
		install.! !

!View methodsFor: 'view-cross-cutting-concern' stamp: ''!
if: aBlock do: anotherBlock insteadOf: aSelector

	| concern |
	concern := self concerns at: aSelector
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].
	concern 
		compiledMethod: self class >> aSelector;
		instead: anotherBlock;
		insteadCondition: aBlock;
		install.! !

!View methodsFor: 'view-visibility' stamp: ''!
message: aSelector isVisibleFrom: aCollectionOfClasses

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].

	concern 
		compiledMethod: self class >> aSelector;
		visibleFromCollection: aCollectionOfClasses;
		install.! !

!View methodsFor: 'view-visibility' stamp: ''!
private: aSelector

	self message: aSelector isVisibleFrom: { self class }! !

!View methodsFor: 'view-visibility' stamp: ''!
protected: aSelector

	self message: aSelector isVisibleFrom:  (self class allSubclasses add: self class) ! !

!View methodsFor: 'view-visibility' stamp: ''!
public: aSelector

	|concern| 

	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].

	concern 
		visibleFromCollection: nil.! !

!View methodsFor: 'view-dynamic-state' stamp: ''!
remove: anId
		
	^ (self getShared: self) 
			ifNil: [ nil ]
			ifNotNilDo: [ :dynIvs | dynIvs removeKey: anId ]
! !

!View methodsFor: 'view-dynamic-state' stamp: ''!
removeShared: anId
		
	^ self class removeProperty: anId
! !

!View methodsFor: 'view-dynamic-state' stamp: ''!
set: anId to: anObject

	^ ((self getShared: self) ifNil: [ self setShared: self to: Dictionary new ])  
			at: anId put: anObject.
		
	
! !

!View methodsFor: 'view-dynamic-state' stamp: ''!
setShared: anId to: anObject

	^ self class propertyValueAt: anId put: anObject! !

!Visibility methodsFor: 'view-visibility' stamp: 'NickPapoulias 8/26/2015 18:38'!
hidden: aSelector

	|concern| 

	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].

	concern 
		visibleFromCollection: {}.! !

!Visibility methodsFor: 'view-visibility' stamp: 'NickPapoulias 8/26/2015 20:41'!
message: aSelector isVisibleFrom: aCollectionOfClasses

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].

	concern 
		compiledMethod: self class >> aSelector;
		visibleFromCollection: aCollectionOfClasses;
		install.! !

!Visibility methodsFor: 'view-visibility' stamp: 'NickPapoulias 8/26/2015 18:10'!
private: aSelector

	self message: aSelector isVisibleFrom: { self class }! !

!Visibility methodsFor: 'view-visibility' stamp: 'NickPapoulias 8/26/2015 18:37'!
protected: aSelector

	self message: aSelector isVisibleFrom:  (self class allSubclasses add: self class) ! !

!Visibility methodsFor: 'view-visibility' stamp: 'NickPapoulias 8/26/2015 18:31'!
public: aSelector

	|concern| 

	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].

	concern 
		visibleFromCollection: nil.! !

TestCase subclass: #TestAClassWithAView
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fun-With-Traits'!

!TestAClassWithAView methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/26/2015 17:21'!
cleanUp

	a remove: #x.
	a removeShared: #y.
	a clearAllConcerns.! !

!TestAClassWithAView methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/26/2015 15:55'!
setUp

	a := AClassWithAView new.
	b := AClassWithAView new.
	self cleanUp! !

!TestAClassWithAView methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/26/2015 12:06'!
tearDown

	self cleanUp! !

!TestAClassWithAView methodsFor: 'test-cross-cutting-concerns' stamp: 'NickPapoulias 8/26/2015 17:36'!
testAfter

	|action trueCondition falseCondition |

	action := [ :selector :args :receiver :returnValue | 
						self assert: (selector = #testMethod).
						self assert: (args isEmpty).
						self assert: (receiver = a).
						self assert: (returnValue = 42). 666 ]. 

	trueCondition := [ :selector :args :receiver :returnValue | true ]. 
	falseCondition := [ :selector :args :receiver :returnValue | false ].

	self assert: (a testMethod = 42).
	a do: action after: #testMethod.
	self assert: (a testMethod = 666).
	a clearConcernOf: #testMethod.
	self assert: (a testMethod = 42).
	
	a if: trueCondition do: action after: #testMethod. 
	self assert: (a testMethod = 666).
	a clearConcernOf: #testMethod.
	self assert: (a testMethod = 42).
	
	a if: falseCondition do: action after: #testMethod. 
	self assert: (a testMethod = 42).
	a clearConcernOf: #testMethod.
	self assert: (a testMethod = 42).! !

!TestAClassWithAView methodsFor: 'test-cross-cutting-concerns' stamp: 'NickPapoulias 8/26/2015 17:43'!
testBefore

	|action trueCondition falseCondtion jumped |

	action := [ :selector :args :receiver | 
						self assert: (selector = #testMethod).
						self assert: (args isEmpty).
						self assert: (receiver = a). 
						jumped := true]. 

	trueCondition := [ :selector :args :receiver | true ]. 
	falseCondtion := [ :selector :args :receiver | false ].

	self assert: (a testMethod = 42).

	a do: action before: #testMethod.
	jumped := false.
	self assert: (a testMethod = 42).
	self assert: (jumped = true).
	a clearConcernOf: #testMethod.
	self assert: (a testMethod = 42).
	
	a if: trueCondition do: action before: #testMethod. 
	jumped := false.
	self assert: (a testMethod = 42).
	self assert: (jumped = true).
	a clearConcernOf: #testMethod.
	self assert: (a testMethod = 42).
	
	a if: falseCondtion do: action before: #testMethod. 
	jumped := false.
	self assert: (a testMethod = 42).
	self assert: (jumped = false).
	a clearConcernOf: #testMethod.
	self assert: (a testMethod = 42).! !

!TestAClassWithAView methodsFor: 'test-dynamic-state' stamp: 'NickPapoulias 8/26/2015 11:48'!
testDynIv

	self assert: (a get: #x) = nil.
	self assert: (a set: #x to: 3) = 3.
	self assert: (a get: #x) = 3.
	self assert: (b get: #x) = nil.! !

!TestAClassWithAView methodsFor: 'test-dynamic-state' stamp: 'NickPapoulias 8/26/2015 11:53'!
testDynSharedIv

	self assert: (a getShared: #y) = nil.
	self assert: (a setShared: #y to: 3) = 3.
	self assert: (b getShared: #y) = 3.! !

!TestAClassWithAView methodsFor: 'test-cross-cutting-concerns' stamp: 'NickPapoulias 8/26/2015 17:37'!
testInstead

	|action trueCondition falseCondition |

	action := [ :selector :args :receiver | 
						self assert: (selector = #testMethod).
						self assert: (args isEmpty).
						self assert: (receiver = a). 666 ]. 

	trueCondition := [ :selector :args :receiver  | true ]. 
	falseCondition := [ :selector :args :receiver  | false ].

	self assert: (a testMethod = 42).
	a do: action insteadOf: #testMethod.
	self assert: (a testMethod = 666).
	a clearConcernOf: #testMethod.
	self assert: (a testMethod = 42).
	
	a if: trueCondition do: action insteadOf: #testMethod. 
	self assert: (a testMethod = 666).
	a clearConcernOf: #testMethod.
	self assert: (a testMethod = 42).
	
	a if: falseCondition do: action insteadOf: #testMethod. 
	self assert: (a testMethod = 42).
	a clearConcernOf: #testMethod.
	self assert: (a testMethod = 42).! !

!TestAClassWithAView methodsFor: 'test-visibility' stamp: 'NickPapoulias 8/26/2015 18:43'!
testVisibility

	self assert: (a testMethod = 42).
	a protected: #testMethod.
	self should: [ a testMethod ] raise: MessageNotUnderstood.
	a public: #testMethod. 
	self assert: (a testMethod = 42).! !

Object subclass: #AClassWithAView
	uses: View
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fun-With-Traits'!

AClassWithAView class
	uses: View classTrait
	instanceVariableNames: ''!

!AClassWithAView methodsFor: 'view-cross-cutting-concern' stamp: ''!
clearAllConcerns

	self concerns keysDo: [ :selector | self clearConcernOf: selector ]! !

!AClassWithAView methodsFor: 'view-cross-cutting-concern' stamp: ''!
clearConcernOf: aSelector 

	(self concerns removeKey: aSelector ifAbsent: [ nil ])
		ifNotNilDo: [:wrapper | wrapper uninstall ]! !

!AClassWithAView methodsFor: 'view-cross-cutting-concern' stamp: ''!
concernOf: aSelector

	^ self concerns at: aSelector ifAbsent: [ nil ]! !

!AClassWithAView methodsFor: 'view-cross-cutting-concern' stamp: ''!
concerns

	^ (self getShared: #concerns) 
		ifNil: [ self setShared: #concerns to: Dictionary new ]! !

!AClassWithAView methodsFor: 'view-cross-cutting-concern' stamp: ''!
do: anotherBlock after: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].
	concern 
		compiledMethod: self class >> aSelector;
		after: anotherBlock;
		install.! !

!AClassWithAView methodsFor: 'view-cross-cutting-concern' stamp: ''!
do: anotherBlock before: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new ].
	concern 
		compiledMethod: self class >> aSelector;
		before: anotherBlock;
		install.! !

!AClassWithAView methodsFor: 'view-cross-cutting-concern' stamp: ''!
do: anotherBlock insteadOf: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new ].
	concern 
		compiledMethod: (self class >> aSelector);
		instead: anotherBlock;
		install.! !

!AClassWithAView methodsFor: 'view-dynamic-state' stamp: ''!
get: anId

	^ (self getShared: self) 
			ifNil: [ nil ]  
			ifNotNilDo: [:dynIvs | dynIvs at: anId ifAbsent: [ nil ]]
! !

!AClassWithAView methodsFor: 'view-dynamic-state' stamp: ''!
getShared: anId

	^ self class propertyValueAt: anId! !

!AClassWithAView methodsFor: 'view-visibility' stamp: ''!
hidden: aSelector

	|concern| 

	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].

	concern 
		visibleFromCollection: {}.! !

!AClassWithAView methodsFor: 'view-cross-cutting-concern' stamp: ''!
if: aBlock do: anotherBlock after: aSelector

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].
	concern 
		compiledMethod: (self class >> aSelector);
		after: anotherBlock;
		afterCondition: aBlock;
		install.! !

!AClassWithAView methodsFor: 'view-cross-cutting-concern' stamp: ''!
if: aBlock do: anotherBlock before: aSelector

	| concern |
	concern := self concerns at: aSelector
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new ].
	concern 
		compiledMethod:  self class >> aSelector;
		before: anotherBlock;
		beforeCondition: aBlock;
		install.! !

!AClassWithAView methodsFor: 'view-cross-cutting-concern' stamp: ''!
if: aBlock do: anotherBlock insteadOf: aSelector

	| concern |
	concern := self concerns at: aSelector
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].
	concern 
		compiledMethod: self class >> aSelector;
		instead: anotherBlock;
		insteadCondition: aBlock;
		install.! !

!AClassWithAView methodsFor: 'view-visibility' stamp: ''!
message: aSelector isVisibleFrom: aCollectionOfClasses

	| concern |
	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].

	concern 
		compiledMethod: self class >> aSelector;
		visibleFromCollection: aCollectionOfClasses;
		install.! !

!AClassWithAView methodsFor: 'view-visibility' stamp: ''!
private: aSelector

	self message: aSelector isVisibleFrom: { self class }! !

!AClassWithAView methodsFor: 'view-visibility' stamp: ''!
protected: aSelector

	self message: aSelector isVisibleFrom:  (self class allSubclasses add: self class) ! !

!AClassWithAView methodsFor: 'view-visibility' stamp: ''!
public: aSelector

	|concern| 

	concern := self concerns at: aSelector 
		ifAbsent: [ self concerns at: aSelector put: SubjectiveConcern new].

	concern 
		visibleFromCollection: nil.! !

!AClassWithAView methodsFor: 'view-dynamic-state' stamp: ''!
remove: anId
		
	^ (self getShared: self) 
			ifNil: [ nil ]
			ifNotNilDo: [ :dynIvs | dynIvs removeKey: anId ]
! !

!AClassWithAView methodsFor: 'view-dynamic-state' stamp: ''!
removeShared: anId
		
	^ self class removeProperty: anId
! !

!AClassWithAView methodsFor: 'view-dynamic-state' stamp: ''!
set: anId to: anObject

	^ ((self getShared: self) ifNil: [ self setShared: self to: Dictionary new ])  
			at: anId put: anObject.
		
	
! !

!AClassWithAView methodsFor: 'view-dynamic-state' stamp: ''!
setShared: anId to: anObject

	^ self class propertyValueAt: anId put: anObject! !

!AClassWithAView methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/26/2015 16:00'!
testMethod

	^ 42! !

Object variableSubclass: #Cache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fun-With-Traits-Sketch-Cache-MOP'!

!Cache methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/27/2015 15:23'!
meta

	"retrieve your meta-object"! !

Object variableSubclass: #Concern
	instanceVariableNames: 'before after instead compiledMethod beforeCondition afterCondition insteadCondition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fun-With-Traits'!

!Concern class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/26/2015 15:09'!
on: aCompiledMethod 
	^self new
		compiledMethod: aCompiledMethod
! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:08'!
after
	^ after! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:08'!
after: anObject
	after := anObject! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:49'!
afterCondition
	^ afterCondition! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:49'!
afterCondition: anObject
	afterCondition := anObject! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 17:40'!
afterRun: aSelector with: anArray in: aReceiver thatReturned: aReturnValue	
		
	^ after ifNotNilDo: [ :block | 
					afterCondition 
						ifNil: [after value: aSelector value: anArray value: aReceiver value: aReturnValue]
						ifNotNil: [(afterCondition value: aSelector value: anArray value: aReceiver value: aReturnValue) 
											ifTrue: [after value: aSelector value: anArray value: aReceiver value: aReturnValue]
											ifFalse: [aReturnValue]]]
			ifNil: [ aReturnValue ]! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:08'!
before
	^ before! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:08'!
before: anObject
	before := anObject! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:49'!
beforeCondition
	^ beforeCondition! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:49'!
beforeCondition: anObject
	beforeCondition := anObject! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 17:28'!
beforeRun: aSelector with: anArray in: aReceiver	
	
	before ifNotNilDo: [ :block | 
					beforeCondition 
						ifNil: [before value: aSelector value: anArray value: aReceiver]
						ifNotNil: [(beforeCondition value: aSelector value: anArray value: aReceiver) 
											ifTrue: [before value: aSelector value: anArray value: aReceiver]]]! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:09'!
compiledMethod
	^ compiledMethod! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 17:21'!
compiledMethod: anObject
	compiledMethod := anObject! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:09'!
doesNotUnderstand: aMessage
	^aMessage sendTo: compiledMethod! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 16:17'!
handleBeforeWith: aReceiver

	| aSelector anArray |
	before ifNotNilDo: [ :block | 
					beforeCondition 
						ifNil: [before value: aReceiver value: aSelector value: anArray]
						ifNotNil: [(beforeCondition value: aReceiver value: aSelector value: anArray) 
											ifTrue: [before value: aReceiver value: aSelector value: anArray]]]! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:21'!
install

	compiledMethod methodClass basicAddSelector: compiledMethod selector withMethod: self! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:08'!
instead
	^ instead! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:08'!
instead: anObject
	instead := anObject! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:49'!
insteadCondition
	^ insteadCondition! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 15:49'!
insteadCondition: anObject
	insteadCondition := anObject! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 17:28'!
insteadRun: aSelector with: anArray in: aReceiver	
	
	instead ifNotNilDo: [ :block | 
					insteadCondition 
						ifNil: [instead value: aSelector value: anArray value: aReceiver]
						ifNotNil: [(insteadCondition value: aSelector value: anArray value: aReceiver) 
											ifTrue: [instead value: aSelector value: anArray value: aReceiver]
											ifFalse: [self executeMethod]]]! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 17:57'!
run: aSelector with: anArray in: aReceiver	
	
	^ instead 
		ifNil: [ 
			self beforeRun: aSelector with: anArray  in: aReceiver.  
			self "will return the appropriate value"
				afterRun: aSelector with: anArray  in: aReceiver 
				thatReturned: (compiledMethod valueWithReceiver: aReceiver arguments: anArray)]
		ifNotNil: [
			insteadCondition 
				ifNil: [ instead value: aSelector value: anArray value: aReceiver ] 
			 	ifNotNil: [ (insteadCondition value: aSelector value: anArray value: aReceiver)
									ifTrue: [ instead value: aSelector value: anArray value: aReceiver ]
									ifFalse: [ compiledMethod valueWithReceiver: aReceiver arguments: anArray ] ]
		]
	! !

!Concern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 17:34'!
uninstall

	compiledMethod methodClass basicAddSelector: compiledMethod selector withMethod: compiledMethod! !

Concern variableSubclass: #SubjectiveConcern
	instanceVariableNames: 'visibleFromCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fun-With-Traits'!

!SubjectiveConcern methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/26/2015 18:25'!
run: aSelector with: anArray in: aReceiver	
	
	^ visibleFromCollection 
		ifNil: [ super run: aSelector with: anArray in: aReceiver ]
		ifNotNil: [ (visibleFromCollection includes: thisContext sender class)
							ifTrue: [ super run: aSelector with: anArray in: aReceiver ]
							ifFalse: [ aReceiver doesNotUnderstand: (Message selector: aSelector arguments: anArray)  ] ]
	
	 ! !

!SubjectiveConcern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 18:21'!
visibleFromCollection
	^ visibleFromCollection! !

!SubjectiveConcern methodsFor: 'accessing' stamp: 'NickPapoulias 8/26/2015 18:21'!
visibleFromCollection: anObject
	visibleFromCollection := anObject! !

Object variableSubclass: #MetaCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fun-With-Traits-Sketch-Cache-MOP'!

!MetaCache methodsFor: 'placement-mop' stamp: 'NickPapoulias 8/27/2015 15:11'!
direct! !

!MetaCache methodsFor: 'cache-miss-mop' stamp: 'NickPapoulias 8/27/2015 15:15'!
fifo! !

!MetaCache methodsFor: 'placement-mop' stamp: 'NickPapoulias 8/27/2015 15:11'!
fullyAssoc! !

!MetaCache methodsFor: 'cache-miss-mop' stamp: 'NickPapoulias 8/27/2015 15:14'!
lru! !

!MetaCache methodsFor: 'writting-mop' stamp: 'NickPapoulias 8/27/2015 15:25'!
noWriteAllocate! !

!MetaCache methodsFor: 'cache-miss-mop' stamp: 'NickPapoulias 8/27/2015 15:14'!
random! !

!MetaCache methodsFor: 'placement-mop' stamp: 'NickPapoulias 8/27/2015 15:11'!
setAssoc: n! !

!MetaCache methodsFor: 'searching-mop' stamp: 'NickPapoulias 8/27/2015 15:14'!
setSearchingPolicyTo: aCacheSearchingPolicy! !

!MetaCache methodsFor: 'size-mop' stamp: 'NickPapoulias 8/27/2015 15:17'!
setSize: n! !

!MetaCache methodsFor: 'backend-mop' stamp: 'NickPapoulias 8/27/2015 15:19'!
usingBackend: aCacheBackEnd! !

!MetaCache methodsFor: 'writting-mop' stamp: 'NickPapoulias 8/27/2015 15:18'!
writeAllocate! !

!MetaCache methodsFor: 'writting-mop' stamp: 'NickPapoulias 8/27/2015 15:16'!
writeBack! !

!MetaCache methodsFor: 'writting-mop' stamp: 'NickPapoulias 8/27/2015 15:16'!
writeThrough! !

Object subclass: #NaiveCacheDetector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fun-With-Traits'!

!NaiveCacheDetector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/27/2015 14:01'!
LRUCacheUsers

	^ LRUCache allCallsOnIn: SystemNavigation new ! !

!NaiveCacheDetector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/27/2015 14:02'!
TTLCacheUsers

	^ TTLCache allCallsOnIn: SystemNavigation new ! !

!NaiveCacheDetector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/26/2015 21:04'!
cachesForClass: aClass

	^ aClass instanceVariables ifNil: [ {  } ] ifNotNilDo: 
		[:ivs | ivs select: [ :iv | iv includesSubstring: 'cache' caseSensitive: false ]]! !

!NaiveCacheDetector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/27/2015 12:09'!
cachesInSystem
	"self new cachesInSystem"
	|classToCacheDict|
	classToCacheDict := Dictionary new.
	ProtoObject allSubclasses do: 
		[ :class | 
			(self cachesForClass: class) 
				ifNotEmptyDo: [:caches | classToCacheDict at: class put: caches ] ].
	^ classToCacheDict ! !
